pico-8 cartridge // http://www.pico-8.com
version 16
__lua__
--solar system demo
--doc_robs, 2018

--variables
sun={
	x=64,
	y=64,
	g=500,
	r=3,
	c=10,
}

num_planets=1

planets={}

blank_timer_max=600
blank_timer=blank_timer_max

function _init()
	cls()
	for i=1,num_planets do
		generate_planet()
	end
end
-->8
--functions

function generate_planet()
 local p={
 	x=sun.x,
 	y=30,
 	g=flr(rnd(2))+1,
 	r=flr(rnd(2))+1,
 	c=flr(rnd(6))+2,
 	vx=rnd(1)+0.5,
 	vy=0-rnd(1)/2,
 	}
 add(planets,p)
end

function move_planet(p,other)
	local dist=0
	local angle=0
	local force=0
	
	--sun
	dist=pythag(sun.x-p.x,sun.y-p.y)		 
	if dist<sun.r then dist=sun.r	end
 angle = atan2(p.x-sun.x,p.y-sun.y)
 force=((1/(dist^2))*sun.g)/10

	p.vx=p.vx-force*cos(angle)
	p.vy=p.vy-force*sin(angle)
	
	--other planets	
	if other then
 	for f in all(planets) do
 		if not(f==p) then
  	 dist=pythag(f.x-p.x,f.y-p.y)	
  	 if dist<f.r then dist=f.r	end	 
    angle = atan2(p.x-f.x,p.y-f.y)
    force=((1/(dist^2))*f.g)/10
  
  		p.vx=p.vx-force*cos(angle)
  		p.vy=p.vy-force*sin(angle)
  	end
 	end
 end
	
	if p.vy>4 then p.vy=4 end
 if p.vy<-4 then p.vy=-4 end
 if p.vx>4 then p.vx=4 end
 if p.vx<-4 then p.vx=-4 end
 		
	--move
	p.x+=p.vx
	p.y+=p.vy
end

function draw_planet(p)
	circfill(p.x,p.y,p.r/2,p.c)
end

function pythag(a,b)
	return sqrt(a^2+b^2)
end


-->8
--draw

function _draw()
	--comment out for trails
	--cls()
	
	draw_planet(sun)
	
	for p in all(planets) do
		draw_planet(p)
	end
end


-->8
--update

function _update60()
	blank_timer-=1
	if blank_timer<0 then 
		blank_timer=blank_timer_max 
		cls()
	end
	for p in all(planets) do
		move_planet(p,false)
	end
end
